import { QueryAllContractStateResponse, QueryCodeResponse, QueryCodesResponse, QueryContractHistoryResponse, QueryContractsByCodeResponse } from '@routerprotocol/chain-api/cosmwasm/wasm/v1/query_pb';
import { ContractAccountsBalanceWithPagination, ContractCodeHistoryEntry, ContractInfo, GrpcContractCodeHistoryEntry, grpcContractInfo, CodeInfoResponse, GrpcCodeInfoResponse } from '../types/custom/wasm';
export declare class ChainGrpcWasmTransformer {
    static allContractStateResponseToContractAccountsBalanceWithPagination(response: QueryAllContractStateResponse): ContractAccountsBalanceWithPagination;
    static contactInfoResponseToContractInfo(contractInfo: grpcContractInfo): ContractInfo;
    static grpcContractCodeHistoryEntryToContractCodeHistoryEntry(entry: GrpcContractCodeHistoryEntry): ContractCodeHistoryEntry;
    static grpcCodeInfoResponseToCodeInfoResponse(info: GrpcCodeInfoResponse): CodeInfoResponse;
    static contactHistoryResponseToContractHistory(response: QueryContractHistoryResponse): {
        entriesList: ContractCodeHistoryEntry[];
        pagination: import("@routerprotocol/chain-api/cosmos/base/query/v1beta1/pagination_pb").PageResponse.AsObject;
    };
    static contractCodesResponseToContractCodes(response: QueryCodesResponse): {
        codeInfosList: CodeInfoResponse[];
        pagination: import("@routerprotocol/chain-api/cosmos/base/query/v1beta1/pagination_pb").PageResponse.AsObject;
    };
    static contractCodeResponseToContractCode(response: QueryCodeResponse): {
        codeInfo: CodeInfoResponse;
        data: string | Uint8Array;
    };
    static contractByCodeResponseToContractByCode(response: QueryContractsByCodeResponse): {
        contractsList: string[];
        pagination: import("@routerprotocol/chain-api/cosmos/base/query/v1beta1/pagination_pb").PageResponse.AsObject;
    };
}
