import { CosmosChainId } from '../../../..';
import type { DirectSignResponse } from '@cosmjs/proto-signing';
import { TxRaw } from '@routerprotocol/chain-api/cosmos/tx/v1beta1/tx_pb';
import { WalletDeviceType } from '../../../types/enums';
import { ConcreteCosmosWalletStrategy } from '../../types/strategy';
export default class Leap implements ConcreteCosmosWalletStrategy {
    chainId: CosmosChainId;
    private leapWallet;
    constructor(args: {
        chainId: CosmosChainId;
    });
    getWalletDeviceType(): Promise<WalletDeviceType>;
    isChainIdSupported(chainId?: CosmosChainId): Promise<boolean>;
    getAddresses(): Promise<string[]>;
    sendTransaction(transaction: DirectSignResponse | TxRaw): Promise<string>;
    signTransaction(transaction: {
        txRaw: TxRaw;
        chainId: string;
        accountNumber: number;
    }, address: string): Promise<DirectSignResponse>;
    getPubKey(): Promise<string>;
    private getLeapWallet;
}
